@use 'src/style/variables' as v;

$labelWidth: 10rem;
$timeline-height: 4rem;
$z-index-now: 1;
$z-index-timeline: 2;
$z-index-dayBars: 3;
$z-index-tasks: 4;
$z-index-head: 5;
$z-index-ruler: 6;
$timeline-active-height: $timeline-height + 1rem;

@mixin Timeline {
  $root: &;

  z-index: $z-index-timeline;
  display: grid;
  grid-template-areas: 'head tasks';
  grid-template-columns: $labelWidth var(--timeline-width, 1fr);
  align-items: center;
  justify-content: flex-start;
  width: min-content;
  height: $timeline-height;
  border-bottom: 1px solid var(--weekPlanning-border);
  background-color: var(--surface-0);

  &--active,
  &--active:nth-child(odd),
  &--active:nth-child(even) {
    height: $timeline-active-height;
    #{$root}__Task {
      height: $timeline-active-height - 2 * v.$spacing-4;
      padding-right: 0;
      padding-bottom: 0;
    }
  }

  &__Head {
    @include TimeLineHead;
  }

  &__Tasks {
    @include TimelineElements;
  }

  &__Task {
    @include TimelineElement;
  }
}

@mixin TimeLineHead {
  position: sticky;
  left: 0;
  z-index: $z-index-head;
  display: grid;
  grid-area: head;
  align-content: center;
  align-self: stretch;
  margin-right: 20px;
  background-color: var(--surface-0);
  word-break: break-all;
}

@mixin TimelineElements {
  position: relative;
  display: block;
  grid-area: tasks;
  width: 100%;
  height: 100%;
  margin: 0;
  padding: 0;
  list-style: none;
}

@mixin TimelineElement {
  position: absolute;
  top: 4px;
  z-index: $z-index-tasks;
  height: $timeline-height - 2 * v.$spacing-4;
}
